;PB0 - STEP
;PB1 - X/Y, 1 => pohyb pisatka, 0 => pohyb papiru
;PC0 - /READY
;PC1 - +/-, 1 => vozik vpravo, papir vzhuru, 0 = > vozik vlevo, papir dolu, test zapnuti plotru
;PC2 - PEN

;programy BASIC G/2
X0000:	EQU		00000h		;studeny start BASICu
X00FD:	EQU		000FDh		;err_09 - chybove hlaseni "Syntax err"
X0554:	EQU		00554h		;tstint - test	cisla ve FP na -32768..+32767
X0614:	EQU		00614h		;"LET"
X0619:	EQU		00619h		;"LET", v DE vlastni parametry
X0788:	EQU		00788h		;"AT"
X07AD:	EQU		007ADh		;cast prikazu "AT"
X08C8:	EQU		008C8h		;numpar - vypocet hodnoty cis. vyrazu, ulozeni do FP
X0AA3:	EQU		00AA3h		;varadr BASICu
X0CB3:	EQU		00CB3h		;zaregistrovani jmena funkce, kontrola jejiho typu
X1600:	EQU		01600h		;podpora LEFT$/RIGHT$/MID$
X1B9A:	EQU		01B9Ah		;SCALE s vlastni hodnotou v DE
X1BD6:	EQU		01BD6h		;prepocet souradnice dle SCALE
X1BD9:	EQU		01BD9h		;-"- od jine adresy
X1BEF:	EQU		01BEFh		;pomocna proedura pro obe souradnice
X1C58:	EQU		01C58h		;presun koncovych souradnic na pocatecni
X1C60:	EQU		01C60h		;-"- od jine adresy
X1EB7:	EQU		01EB7h		;cast prikatu AUTO

;promenne v kodu BASICu
V000E:	EQU		0000Eh		;presmerovani chyby vyhodnoceni RST 008h
V0024:	EQU		00024h		;zde je ulozena adresa PRTOUT MONITORu
V0032:	EQU		00032h		;vyssi byte adresy fpaccum
V1B65:	EQU		01B65h		;parametricka rovnice	@0=-@2*@6 EOL
V1B6F:	EQU		01B6Fh		;parametricka rovnice	@1=-@5*@7 EOL
V1B74:	EQU		01B74h		;cast parametricke rovnice @5*@7 EOL
V1B79:	EQU		01B79h		;parametricka rovnice (@X=)@0+@6*@X EOL
V1B7C:	EQU		01B7Ch		;cast parametricke rovnice @6*@X EOL
V1B7F:	EQU		01B7Fh		;cast parametricke rovnice @X EOL
V1B82:	EQU		01B82h		;parametricka rovnice (@Y=)@1+@7*@Y EOL
V1B85:	EQU		01B85h		;cast parametricke rovnice @7*@Y EOL
V1B88:	EQU		01B88h		;cast parametricke rovnice @Y EOL
V1BB8:	EQU		01BB8h		;modifikace SCALE BASICu - CALL/RET
V1C0F:	EQU		01C0Fh		;vyhodnoceni 'vyjeti' z obrazovky
V1C1A:	EQU		01C1Ah		;-"-
V1C6A:	EQU		01C6Ah		;nahradi instrukci RET instrukci INC A
V1DED:	EQU		01DEDh		;v obsluze LABEL
V1E04:	EQU		01E04h		;JMP do bloku MGF operaci
V1E05:	EQU		01E05h		;adresa obsluhy MGF operaci
V1E06:	EQU		01E06h
V2145:	EQU		02145h		;hodonota v obsluze IMS-2, ENTER
V2332:	EQU		02332h		;zdrojova adresa tohoto programu v ROM-packu
V23FD:	EQU		023FDh		;prepinac RAD/DEG
V5E72:	EQU		05E72h		;byte 05E je nahrazen vyssim byte adresy fpaccum

;programy MONITORu PMD-85/2
M8113:	EQU		08113h		;"CLR" - vymezerovani editacniho buferu
M813B:	EQU		0813Bh		;"PREVO2" - prevod BIN na 2xASCII
M8500:	EQU		08500h		;"PRTOUT" - vypsani znaku na monitor
M8855:	EQU		08855h		;"WRBUFF" - vypis textu editacni radky na monitor
M89C0:	EQU		089C0h		;INKEY - test klavesnice bez cekani
M8C00:	EQU		08C00h		;"ROMIN" - nahrani programu z ROM packu
M8C7D:	EQU		08C7Dh		;"POINT" - vykresleni bodu
M8CD0:	EQU		08CD0h		;"INPOL" - linearni interpolator
M8E43:	EQU		08E43h		;"PRBTXT" - vypis chyboveho hlaseni

;******************************************************************************
;Adresa zavedeni programu z ROM-packu, provadi modifikaci basicu a kopiruje
;program po 16 bytech z ROM-packu do "oken" vedle VRAM
;******************************************************************************
L7000:	PUSH	HL			;ulozeni ukazatel BASICu
	LD	HL,(V2332)		;zdrojova adresa tohoto programu v ROM-packu - prikaz ROM BASICu
	PUSH	HL			;schovej si prectenou hodnotu - standardne 02400h
	LD	DE,00240h		;offset 1. prenaseneho bloku tohoto programu z ROM-packu
	ADD	HL,DE			;spocti adresu 1. bloku - 02640h
	LD	(V7012),HL		;tabulka parametru pro ROMIN monitoru
	LD	B,0E9h			;kolik "oken" vedle VRAM se bude plnit
L700E:	PUSH	BC			;schovej si pocitadlo
	CALL	M8C00			;ROMIN monitoru PMD85
V7012:	DW	00000h			;adresa zacatku v ROM-packu - dopocitava se
V7014:	DW	0000Fh			;pocet ctenych byte-1 - nemeni se
V7016:	DW	0C3F0h			;adresa pocatku nacteni v RAM - dopocitava se
	LD	HL,00030h		;vzdalenost mezi volnymi "okny" RAM vedle VRAM
	ADD	HL,DE			;v DE zustava adresa v RAM - vypocet dalsiho "okna"
	LD	(V7016),HL		;dej na misto pro pouziti s ROMIN
	LD	DE,00010h		;velikost "okna" vedle VRAM
	LD	HL,(V7012)		;odkud se cetla data z ROM-packu naposledy
	ADD	HL,DE			;spocti novy pocatek dat v ROM-packu
	LD	(V7012),HL		;dej na misto pro pouziti s ROMIN
	POP	BC			;pocitadlo prenasenych bloku
	DEC	B			;sniz pocitadlo
	JP	NZ,L700E		;pokud neni BC=0 pokracuj dalsim blokem
	CALL	LCF3B			;nastaveni GPIO - PCL=OUT
	POP	HL			;zdrojova adresa tohoto programu v ROM-packu
	LD	(VE0FE),HL		;uloz do programu
	LD	A,(V0032)		;vyssi byte adresy zapisniku interpretu BASICu
	LD	(0C3F2h),A		;	 - bud 05Eh (48kB verze) nebo 0BEh (64kB verze)
	LD	(0C4F2h),A		;	nastaveni stranky interpretu BASICu
	LD	(0C535h),A		;	VC535
	LD	(0C579h),A		;	VC579
	LD	(0C5F9h),A		;	VC5F9
	LD	A,(VC170)		;souradnice bodu X (MONITOR)
	LD	(VFBBE),A
	LD	A,(VC172)		;X souradnice pocatecniho bodu
	LD	(VFC7E),A
	LD	HL,(VFFB0)
	LD	(VFC3C),HL
	LD	HL,(VFFB2)
	LD	(VFC3E),HL
	LD	HL,V7077		;pocatek tabulky pro modifikaci BASICu
L7062:	LD	E,(HL)			;precti byte z tabulky
	INC	HL			;posun ukazatel v tabulce
	LD	D,(HL)			;precti byte z tabulky - v DE cilova adresa
	INC	DE			;0FFFFh v DE signalizuje konec modifikacni tabulky
	LD	A,E
	OR	D
	JP	Z,L7075			;pokud bylo v DE 0FFFFh+1 = 00000h - vyskoc
	DEC	DE			;DE sniz zpatky
	INC	HL			;posun ukazatele v tabulce
	LD	B,(HL)			;precti byte z tabulky - v B delka prenasenych dat
	INC	HL			;posun ukazatele v tabulce
	CALL	LC3F5			;z adresy v HL prenes B byte na adresu v DE
	JP	L7062			;dalsi blok dat z tabulky k presunuti

L7075:	POP	HL			;obnoveni ukazatele BASICu
	RET				;konec inicializace/zavedeni programu

;*******************************************************************************
;Data pro modifikaci BASICu. 1 WORD adresa kam, 1 BYTE delka kopirovanych dat
;a kopirovana data
;*******************************************************************************
V7077:	DW	0002Eh			;pocet znaku na radku pri tisku z BASICu
	DB	001h			;prenasi se 1 znak
	DB	050h			;80 znaku na radek

	DW	006DCh			;prikaz BASICu PRINT, test na AT
	DB	002h
	DB	070h,0F2h		;adresa obsluhy X0788 nahrazena LF270

	DW	00788h			;vstupni bod prikazu AT
	DB	002h
	DB	0F1h,0E1h		;puvodni RST 010h+RST 020h nahrazeno POP SP+POP HL

	DW	007A9h			;dalsi cast prikazu AT
	DB	003h
	DB	0C3h,0BAh,0F2h		;EX DE,HL; RST 008h; DB ',' nahrazeno JP 0F2BAh

	DW	00C51h			;procedura DEF
	DB	002h
	DB	070h,0F7h		;CALL X0CB3 nahrazeno CALL LF770

	DW	01934h			;vektor interpretace AXES
	DB	002h
	DB	0B0h,0EDh		;c_axes nahrazeno LEDB0

	DW	0194Ah			;vektory interpretace LABEL a FILL
	DB	004h
	DB	045h,01Eh,038h,0FBh	;c_labl a c_fill nahrazeno X1E45 a LFB38
					;X1E45 - nacteni zvetsovacich parametru pro LABEL

	DW	01974h			;nove vektory s tokeny 0EAh (COPYx) a 0EBh (HARD)
	DB	004h
	DB	0FBh,0EFh,0B0h,0FCh	;LEFFB (COPYx) + LFCB0 (HARD)

	DW	01AC0h			;dekodovaci tabulka textu prikazu BASICu
	DB	004h
	DB	0D4h,059h,050h,045h	;prikaz TYPE misto FILL

	DW	01B15h			;nove prikazy BASICu
	DB	009h
	DB	0C3h,04Fh,050h,059h,0C8h,041h,052h,044h	;prikazy COPY + HARD
	DB	080h			;zarazka dekoderu tokenu prikazu BASICu

	DW	01BB9h			;modifikace SCALE, zpracovani 4. parametru
	DB	002h
	DB	0B0h,0C4h		;X0619 nahrazeno LC4B0

	DW	01BD6h			;prepocet jedne souradnice pomoci SCALE
	DB	003h
	DB	0C3h,0FCh,0C9h		;PUSH BC, PUSH HL,EX DE,HL nahrazeno JMP LC9FC

	DW	01BE4h			;prepocet souradnice pomoci SCALE
	DB	003h
	DB	0C3h,0B0h,0CAh		;CALL tstint nahrazeno JMP LCAB0

	DW	01BEFh			;prepocet obou souradnic
	DB	003h
	DB	0CDh,0F4h,0CAh		;LD B,01B79h nahrazeno CALL LCAF4

	DW	01BF8h			;prepocet obou souradnic
	DB	003h
	DB	0CDh,0B0h,0CBh		;LD (X2),A nahrazeno CALL LCBB0

	DW	01BFDh			;prepocet obou souradnic
	DB	003h
	DB	0CDh,070h,0CBh		;LD BC,X1B82 nahrazeno CALL LCB70

	DW	01C0Bh			;prepocet obou souradnic
	DB	003h
	DB	0CDh,0B9h,0CBh		;LD (Y2),A je nahrazeno CALL LCBB9

	DW	01C1Fh			;prepocet obou souradnic
	DB	001h
	DB	000h			;LD E,000h je nahrazeno NOP; NOP

	DW	01C23h			;prikaz PLOT BASICu
	DB	002h
	DB	0F0h,0F6h		;X1BEF nahrazeno LF6F0

	DW	01C37h			;prikaz PLOT BASICu
	DB	002h
	DB	0F0h,0EFh		;X1C90 nahrazeno LEFF0

	DW	01C3Dh			;prikaz PLOT BASICu
	DB	006h
	DB	021h,07Dh,0DDh		;CALL X1C58 nahrazeno LD HL,VDD7D
	DB	0CDh,0B0h,0F8h		;CALL Z,point nahrazeno CALL LF8B0


	DW	01C51h			;prikaz MOVE BASICu
	DB	002h
	DB	0F0h,0F6h		;X1BEF nahrazeno LF6F0

	DW	01C5Dh			;prikaz MOVE BASICu
	DB	003h
	DB	0C3h,0B7h,0F6h		;LD A,(X2) nahrazeno JMP LF6B7

	DW	01C6Bh			;prepsani AXES BASICu tabulkou hodnot
	DB	030h
	DB	001h,002h,002h,003h,003h,004h,004h,005h
	DB	005h,006h,007h,008h,009h,00Ah,00Bh,00Ch
	DB	00Dh,00Eh,00Fh,010h,011h,012h,013h,014h
	DB	015h,016h,018h,01Ah,01Ch,01Eh,020h,022h
	DB	024h,026h,028h,02Ah,02Dh,030h,034h,038h
	DB	03Ch,040h,044h,048h,04Ch,050h,054h,058h

;LOW byte offsetu generatoru jednotlivych znaku, HIGH byte dle znaku je 015h, 016h nebo 017h
	DW	01D75h			;prepsani MAGBYT BASICu tabulkou hodnot
	DB	08Fh
	DB	047h,04Eh,051h
	DB	057h,05Dh,066h,070h,076h,07Ch,081h,086h	;01D78h
	DB	08Bh,090h,097h,09Ah,09Dh,0A1h,0A5h,0AAh	;01D80h
	DB	0AFh,0B5h,0BBh,0BCh,0C0h,0C5h,0CBh,0D5h	;01D88h
	DB	0E1h,0EDh,0F0h,0F7h,0FEh,005h,009h,00Ch	;01D90h
	DB	00Fh,011h,014h,018h,01Eh,022h,026h,02Ch	;01D98h
	DB	031h,03Bh,040h,04Eh,058h,05Bh,05Eh,062h	;01DA0h
	DB	067h,06Bh,070h,07Bh,083h,089h,092h,09Ah	;01DA8h
	DB	09Eh,0A4h,0A9h,0B0h,0B7h,0BDh,0C4h,0C8h	;01DB0h
	DB	0CEh,0D3h,0D6h,0DEh,0E2h,0E6h,0F3h,0F7h	;01DB8h
	DB	0FEh,002h,008h,00Ch,012h,017h,01Ch,01Fh	;01DC0h
	DB	024h,029h,02Eh,031h,03Eh,042h,04Bh,04Fh	;01DC8h
	DB	053h,05Ah,061h,065h,06Ch,074h,07Bh,081h	;01DD0h
	DB	08Eh,092h,095h,099h,09Dh,0A4h,0AFh,0B7H	;01DD8h
	DB	0BEh,0C2h,0C8h,0CDh,0D3h,0D8h,0E2h,0E7h	;01DE0h
	DB	0F1h,0F8h,0FFh,0FFh,0FFh,039h,030h,0A6h	;01DE8h
	DB	040h,058h,0A6h,0B9h,028h,040h,046h,029h	;01DF0h
	DB	000h,039h,030h,0A6h,040h,058h,0A6h,0BAh	;01DF8h
	DB	028h,040h,046h,029h			;01E00h

	DW	01E07h			;prepsani X1E07 tabulkou hodnot
	DB	029h
	DB	036h,0A6h,040h,059h,0A7h,0B9h,028h,040h
	DB	050h,029h,0A6h,0BAh,028h,040h,050h,0A4h
	DB	040h,046h,029h,000h,039h,038h,0A6h,040h
	DB	059h,0A7h,0B9h,028h,040h,050h,029h,0A6h
	DB	0B9h,028h,040h,050h,0A4h,040h,046h,029h
	DB	000h

	DW	01E35h			;presmerovani std. tisku prtout
	DB	002h
	DB	035h,0EFh		;LD HL,M8500 nahrazeno LD HL,LEF35

	DW	01E45h			;prepsani casti LABEL novym kodem
	DB	019h
	DB	07Eh			;LD	A,(HL)			
	DB	0FEh,0A6h		;CP	0A6h
	DB	0C4h,0F5h,0CBh		;CALL	NZ,LCBF5
	DB	0D7h			;RST	010h
	DB	0CFh			;RST	008h
	DB	03Bh			;';'
	DB	011h,0B0h,0F4h		;LD	DE,VF4B0
	DB	03Eh,0C8h		;LD	A,0C8h
	DB	0CDh,0B9h,0F4h		;CALL	LF4B9
	DB	0EBh			;EX	DE,HL
	DB	022h,024h,000h		;LD	(V0024),HL
	DB	0EBh			;EX	DE,HL
	DB	0C3h,030h,01Eh		;JP	X1E30 - zde je CALL X06C9

	DW	01E67h			;modifikace DISP BASICu
	DB	001h
	DB	056h			;X1E2B nahrazeno X1E56

	DW	02343h			;modifikace GCLEAR BASICu
	DB	002h
	DB	0FAh,0F5h		;M8C00 nahrazeno LF5FA

	DW	02145h			;vystupni buffer driveru IMS-2
	DB	001h
	DB	03Ch			;nizsi byte adresy buferu IMS-2 nahrazeno 03Ch
					;puvodni hodnota

	DW	0C1FAh			;rutina pixelovych operaci BASICu
	DB	001h
	DB	0B0h			;XOR B je nahrazeno OR B

	DW	01B65h			;prepocet internich grafickych promennych BASICu
	DB	001h
	DB	040h			;umisteni znaku '@' na puvodni pozici

	DB	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh	;konec modifikacni tabulky BASICu
	DB	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
	DB	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh

;*******************************************************************************
;zacatek VRAM a "oken" RAM vedle VRAM
;*******************************************************************************
	ORG	0C030h
VC030:	DB	000h,07Fh		;zacatek editacniho bufferu
	DB	0C0h,0FFh,04Fh,07Fh,000h,000h,000h,07Fh
VC03A:	DB	000h			;atribut barvy
	DB	045h,000h,085h
VC03E:	DB	040h,0C9h		;adresa pro tisk znaku

	ORG	0C070h
VC070:	DB	0FFh,07Fh
VC072:	DB	000h,000h		;ukaz. do edit. buferu pri cteni
VC074:	DB	082h,07Fh		;adresa systemoveho hlaseni
VC076:	DB	012h,003h
VC078:	DB	007h,05Eh		;adresa textu pro editaci radku
	DB	0FBh,05Dh,01Bh,000h,0B6h,083h

	ORG	0C0B0h
VC0B0:	DB	000h,0FFh,008h,086h,008h,087h,0C8h,088
	DB	000h,0FFh,000h,0FFh,000h,0FFh,000h,0FFh

	ORG	0C0F0h
LC0F0:	DB	000h,0C3h,088h,08Ah	;navratovy vektor u MGF operaci	
	DB	0EAh,009h,0B0h,0FAh,000h,0FDh,0FBh,030h
	DB	040h,002h,030h,020h

	ORG	0C130h
VC130:	DB	0F4h,080h,06Fh,083h,00Dh,000h,000h,000h
	DB	03Eh,080h,052h,07Fh,003h,000h,020h,045h

;promenne BASICu
	ORG	0C170h
VC170:	DB	078h,065h		;X souradnice pocatecniho bodu
VC172:	DB	063h			;Y souradnice pocatecniho bodu
VC173:	DB	075h			;X souradnice koncoveho bodu
VC174:	DB	074h			;Y souradnice koncoveho bodu
VC175:	DB	0C0h,0FFh		;pomocna promenna
	DB	065h,07Fh,000h,02Bh
VC17A:	DB	00Dh,000h		;ukaz. pro BMOVE/BPLOT
	DB	07Fh,000h,07Dh

	ORG	0C1B0h
VC1B0:	DB	02Bh,02Bh
LC1B2:	CALL	M8C00			;sem MONITOR nahrava prvnich 13 byte
	DW	0000Ch			;z ROM-packu. Pokud je na LC1B2 instrukce
	DW	023F4h			;CALL (0CDh) preda ji rizeni. Zde je
	DW	00000h			;tedy automaticke natazeni BASICu do RAM
	JP	X0000			 ;a jeho spusteni
VC1BE:	DB	021h,082h

	ORG	0C1F0h
VC1F0:	DB	020h
VC1F1:	DB	02Bh			;priznak chraneneho souboru 02Ah
	DB	02Bh,00Dh
;kod bitovych operaci kresleni		;kresli		maze		invertuje
LC1F4:	LD	A,(HL)			;LD	A,(HL)	LD	A,(HL)	LD	A,(HL)
	CP	03Fh			;AND	03Fh	CP	03Fh	CP	03Fh
	CP	000h			;OR	000h	CP	000h	CP	000h
	NOP				;NOP		CPL		NOP
	OR	B			;OR	B	OR	B	XOR B
	NOP				;NOP		CPL		NOP
	LD	(HL),A			;LD	(HL),A	LD	(HL),A	LD	(HL),A
	RET				;RET		RET		RET
VC1FE:	DB	0ABh,006h		;konstanta rychlosti pro MGF

	ORG	0C330h
VC330:	DB	000h,000h		;arrlen - delka pole promennych
	DB	000h,000h
VC334:	DB	000h,000h		;imsptr - ukazatel do IMSBUF
	DB	000h,000h,000h,000h
VC33A:	DB	000h,000h,000h,000h,000h,000h	;imsbuf - bufer hlavicky protokolu IMS-2

;******************************************************************************
;Prvni "okno" vedle VRAM, kam se nacita obsah ROM-packu obsluhy XY41xx.
;Celkem se nacita 0E9h bloku po 010h bytech
;******************************************************************************
	ORG	0C3F0h		;prenese 4 byte z fpaccum na (DE) 
LC3F0:	LD	HL,05E82h	;VC3F2 - fpaccum BASICU
	LD	B,004h		;pocet prenasenych byte
LC3F5:	LD	A,(HL)		;cti byte z pameti
	LD	(DE),A		;uloz byte do pameti
	INC	HL		;dalsi zdrojova adresa
	INC	DE		;dalsi cilova adresa
	DEC	B		;pocitadlo presunutych byte
	RET	Z		;pokud je B=0, navrat
	JP	LC3F5		;kopiruj dalsi byte
VC3FE:	DB	000h,000h

	ORG	0C430h
VC430:	DB	040h,036h,03Ch,032h,035h,035h,030h,0A7h	;@6<2550/
	DB	028h,040h,034h,0A5h,040h,032h,029h,000h	;(@4-@2) EOL

	ORG	0C470h
VC470:	DB	040h,037h,0ACh,031h,037h,030h,030h,0A7h	;@7=1700/
	DB	028h,040h,035h,0A5h,040h,033h,029h,000h	;(@5-@3) EOL

	ORG	0C4B0h		;zpracovani SCALE, test 4. parametru
LC4B0:	CALL	X0619		;volani puvodni obsluhy 4. parametru
	PUSH	HL		;ulozeni ukazatele BASICu
	LD	HL,VC430	;parametricka rovnice @6<2550/(@4-@2) EOL
	CALL	X0614		;puvodni prikaz LET BASICu - vycisleni rovnice
LC4BA:	LD	DE,VFF70	;tabulka 4x4byte - vysledky param. rovnic?
	JP	LC4F0

	ORG	0C4F0h
LC4F0:	LD	HL,(V5E72)	;VC4F2 - crntadr - ukazatel do zdrojoveho kodu BASICu
	LD	(VFFB8),HL	;schovej si crntadr
	CALL	LC3F0		;prenes obsah fpaccum do (DE)
	LD	HL,VC470	;parametricka rovnice @7=1700/(@5-@3) EOL
	PUSH	DE		;uloz si ukazatel do tabulky vysledku
	JP	LC530

	ORG	0C530h
LC530:	CALL	X0614		;puvodni prikaz LET BASICu - vycisleni rovnice
	LD	HL,(V5E72)	;VC535 - crntadr - ukazatel do zdrojoveho kodu BASICu
	LD	(VFFBA),HL	;schovej si crntadr
	POP	DE		;obnov ukazatel do tabulky vysledku
	CALL	LC3F0		;prenes obsah fpaccum do (DE)
	JP	LC570

	ORG	0C570h
LC570:	LD	HL,V1B65	;parametricka rovnice @0=-@2*@6 EOL
	PUSH	DE		;schovej si ukazatel do tabulky vysledku
	CALL	X0614		;puvodni prikaz LET BASICu - vycisleni rovnice
	LD	HL,(V5E72)	;VC579 - crntadr - ukazatel do zdrojoveho kodu BASICu
	LD	(VFFBC),HL	;schovej si crntadr
	JP	LC6F0

	ORG	0C5B0h
LC5B0:	CALL	LC3F0		;prenes obsah fpaccum do (DE)
	LD	HL,V1B74	;parametricka rovnice @1=-@5*@7 EOL
	DEC	(HL)		;upravi @1=-@5*@7 EOL na @1=-@3*@7 EOL
	DEC	(HL)
	PUSH	HL		;schovej si ukazatele
	PUSH	DE
	LD	HL,V1B6F	;parametricka rovnice @1=-@3*@7 EOL
	JP	LC5F0

	ORG	0C5F0h
LC5F0:	CALL	X0614		;prikaz LET BASICu - vycisleni rovnice
	POP	DE		;obnov si ukazatele
	POP	HL
	INC	(HL)		;vrat @1=-@3*@7 EOL na @1=-@5*@7 EOL 
	INC	(HL)
	LD	HL,(V5E72)	;VC5F9 - crntadr - ukazatel do zdrojoveho kodu BASICu
	LD	(VFFBE),HL	;schovej si crntadr
	JP	LC630

	ORG	0C630h
LC630:	CALL	LC3F0		;presun fpaccum do (DE)
	POP	HL		;obnov si ukazatel BASICu
	RET			;navrat
LC635:	LD	DE,VFF70	;odkaz na prehazovana data - 4x4 byty
	LD	HL,VFFB8	;tabulka adres prehazovanych dat - crntadr
	LD	B,004h		;4 skupiny
	JP	LC670

	ORG	0C670h
LC670:	LD	C,B		;po 4 bytech
LC671:	PUSH	BC		;schovej si citace
	LD	A,(HL)		;nizsi byte adresy dat
	INC	HL		;posun v tabulce
	LD	C,(HL)		;vyssi byte adresy dat
	INC	HL		;posun v tabulce
	PUSH	HL		;schovej si ukazatel
	LD	L,A		;do HL dej prectenou adresu
	LD	H,C
	CALL	LC6F4		;prohod 4 byte
	POP	HL		;ukazatel v tabulce adres
	JP	LC6B0

	ORG	0C6B0h
LC6B0:	POP	BC		;obnov si pocitadla
	DEC	C		;sniz pocet prehazovanych skupin
	JP	NZ,LC671	;neni-li C=0 pokracuj dalsi skupinou
	RET			;navrat
VC6B6:	DB	040h,050h,0ACh,030h,000h	;@P=0 EOL
	DB	040h,046h,0ACh,030h,000h	;@F=0 EOL

	ORG	0C6F0h
LC6F0:	POP	DE
	JP	LC5B0
LC6F4:	LD	A,(DE)		;cti byte z (DE)
	LD	C,(HL)		;cti byte z (HL)
	EX	DE,HL		;prohod adresy
	LD	(DE),A		;uloz byte na (DE)
	LD	(HL),C		;uloz byte na (HL)
	INC	DE		;dalsi polozky tabulky
	INC	HL
	DEC	B		;uprav pocitadlo prohozenych byte
	JP	NZ,LC6F4	;neni-li B=0 pokracuj dalsimi byte
	RET			;navrat

	ORG	0C730h
LC730:	LD	A,H		;prevod zaporneho v HL cisla na kladne
	AND	A
	RET	P		;7. bit nenastaven - navrat
LC733:	PUSH	AF		;vypocet dvojkoveho doplnku HL
	XOR	A
	SUB	L
	LD	L,A
	SBC	A,A
	SUB	H
	LD	H,A
	POP	AF
	RET			;navrat
LC73C:	PUSH	BC
	JP	LC770

	ORG	0C770h
LC770:	PUSH	DE
	LD	C,A		;schovej s A
	CALL	LC730		;prevod zaporneho cisla v HL na kladne
	LD	A,C		;obnov si A
	PUSH	AF
	LD	DE,00000h
	LD	B,008h
LC77C:	LD	A,H
	JP	LC7B0

	ORG	0C7B0h
LC7B0:	SUB	C
	JP	C,LC7B9
	INC	DE
	LD	H,A
	JP	LC77C
LC7B9:	ADD	HL,HL
	EX	DE,HL
	ADD	HL,HL
	EX	DE,HL
	JP	LC7F0

	ORG	0C7F0h
LC7F0:	DEC	B
	JP	NZ,LC77C
	LD	A,H
	SUB	C
	JP	C,LC7FB
	INC	DE
	LD	H,A
LC7FB:	LD	A,H
	ADD	A,A
	JP	LC830

	ORG	0C830h
LC830:	SUB	C
	JP	C,LC835
	INC	DE
LC835:	EX	DE,HL
	JP	LC8F4
LC839:	PUSH	BC
	PUSH	DE
	LD	D,A
	XOR	H
	JP	LC870

	ORG	0C870h
LC870:	LD	A,D
	PUSH	AF
	CALL	LC730		;prevod zaporneho cisla na kladne
	LD	E,000h
	LD	B,007h
	EX	DE,HL
	CALL	LC730		;prevod zaporneho cisla na kladne
	JP	LC8B0

	ORG	0C8B0h
LC8B0:	LD	A,H
	LD	H,L
LC8B2:	ADD	A,A
	JP	NC,LC8B7
	ADD	HL,DE
LC8B7:	ADD	HL,HL
	DEC	B
	JP	NZ,LC8B2
	ADD	A,A
	JP	LC8F0

	ORG	0C8F0h
LC8F0:	JP	NC,LC8F4
	ADD	HL,DE
LC8F4:	POP	AF
	CALL	M,LC733		;zaporne - vypocet dvojkoveho doplnku HL
	POP	DE
	POP	BC
	RET
LC8FB:	LD	A,0C9h		;kod instrukce RET assembleru
	JP	LC930

	ORG	0C930h
LC930:	LD	(V1C1A),A	;modifikace pomocne procedury BASICu
	PUSH	HL
	CALL	LC635		;vypocet 4 parametrickych rovnic
	CALL	LCFB0		;inicializace ploteru, vymena papiru?
	CALL	LF536		;
	JP	LC970

	ORG	0C970h
LC970:	PUSH	HL
	CALL	X1BD6		;prepocet jedne souradnice dle SCALE
	RST	008h		;test shody znaku (HL) a za RST 008h
	DB	02Ch		;','
	EX	DE,HL
	LD	(VFFB0),HL
	LD	(VFC3C),HL
	JP	LC9B0

	ORG	0C9B0h
LC9B0:	CALL	LF577
	CALL	X1BD6		;prepocet jedne souradnice dle SCALE
	EX	DE,HL
	LD	(VFFB2),HL
	LD	(VFC3E),HL
	JP	LC9F0

	ORG	0C9F0h
LC9F0:	CALL	LC635
	POP	HL
	LD	A,03Eh		;"LD	A,"
	LD	(V1C1A),A
	JP	X1BEF		;pomoc. proc. graf - obe souradnice
LC9FC:	LD	A,(HL)		;prepocet jedne souradnice pomoci SCALE
	JP	LCA30		;parametry v DE a HL

	ORG	0CA30h
LCA30:	CP	0A6h
	PUSH	AF
	JP	NZ,LCB3A
	RST	010h		;test na cislo 0..9 na (HL)
	LD	A,(HL)
	CP	02Ch		;','
	JP	Z,LCA79
	JP	LCA70

	ORG	0CA70h
LCA70:	CP	03Bh		;';'
	JP	Z,LCA79
	OR	A
	JP	NZ,LCB3A
LCA79:	LD	DE,00000h
	JP	LCAB4
VCA7F:	DB	000h

	ORG	0CAB0h		;presmerovana obsluha tstint BASICu
LCAB0:	CALL	X0554		;puvodni obsluha tstint BASICu
	POP	HL
LCAB4:	POP	AF
	PUSH	HL
	JP	NZ,X1EB7	;cast prikazu AUTO BASICu
	DB	021h		;LD HL,xxxx
VCABA:	DB	000h,000h	;data pro LD HL,xxxx
	ADD	HL,DE
	JP	LCAF0

	ORG	0CAF0h
LCAF0:	EX	DE,HL
	JP	X1EB7		;cast prikazu AUTO BASICu
LCAF4:	PUSH	HL		;presmerovany prepocet obou souradnic BASICu
	LD	HL,(VFBBE)
	LD	(VCABA),HL	;VCABA modifikuje data instrukce "LD HL,xxxx"
	POP	HL
LCAFC:	LD	A,(HL)
	JP	LCB30

	ORG	0CB30h
LCB30:	LD	BC,V1B79	;odkaz do BASICu - "(@X=)@0+@6*@X EOL"
	CP	0A6h		;'*' - token pro nasobeni
	RET	NZ
	LD	BC,V1B7C	;odkaz do BASICu - "@6*@X EOL"
	RET
LCB3A:	PUSH	BC		;3 puvodni instrukce SCALE BASICu
	PUSH	HL
	EX	DE,HL
	JP	X1BD9		;pokracovani puvodniho SCALE BASICu

	ORG	0CB70h
LCB70:	PUSH	HL
	LD	HL,(VFC7E)
	LD	(VCABA),HL	;VCABA modifikuje data instrukce "LD HL,xxxx"
	POP	HL
LCB78:	LD	A,(HL)
	LD	BC,V1B82	;odkaz do BASICu - "(@Y=)@1+@7*@Y EOL"
	JP	LFAB9
	DB	0C9h

	ORG	0CBB0h
LCBB0:	LD	(VC173),A	;X souradnice koncoveho bodu
	EX	DE,HL
	LD	(VFBBE),HL
	EX	DE,HL
	RET
LCBB9:	LD	(VC174),A	;Y souradnice koncoveho bodu
	EX	DE,HL
	JP	LCBF0

	ORG	0CBF0h
LCBF0:	LD	(VFC7E),HL
	EX	DE,HL
	RET
LCBF5:	LD	A,0C9h		;instrukce "RET"
	LD	(V1BB8),A	;modifikace SCALE BASICu - misto CALL je RET
	PUSH	HL
	LD	A,039h		;ADD HL,SP
	JP	LCC30

	ORG	0CC30h
LCC30:	LD	(V1E06),A	;modifikace ovladace LABEL BASICu
	LD	HL,LCDF6	;adresa obsluhy err_09 BASICu
	LD	(V000E),HL	;modifikuj BASIC
	LD	HL,0A500h	;AND L; NOP
	JP	LCC70
VCC3F:	DB	003h		;pohyb X s prednastavenym STEP

	ORG	0CC70h
LCC70:	LD	(V1E04),HL	;JP X2296 je nahrazeno NOP; AND L; ADD HL,SP
	POP	HL		;ukazatel BASICu
	LD	DE,VCEB0	;4 parametricke rovnice pro SCALE
	CALL	X1B9A		;prikaz SCALE s vlastni hodnotou v DE
	CALL	X0619		;prikaz LET s vlastnimi promennymi
	JP	LCCB0

	ORG	0CCB0h
LCCB0:	DEC	HL		;ukazatel BASICu-1
	PUSH	HL		;uazatel BASICu
	CALL	LCDB7		;obnoveni obsluhy "Syntax err"
	LD	A,004h		;pocitadlo pruchodu
	LD	HL,V1DED
LCCBA:	LD	(VCA7F),A	;schovej si pocitadlo
	JP	LCCF0

	ORG	0CCF0h
LCCF0:	CALL	X08C8		;vypocet hodnoty ciselneho vyrazu a vlozeni do FP
	CALL	X0554		;test FP na rozsah -32768 .. +32767
	INC	HL
	PUSH	DE
	LD	A,(VCA7F)	;obnov si pocitadlo
	DEC	A		;sniz pocitadlo pruchodu
	JP	LCD30
VCCFF:	DB	001h		;pohyb Y s prednastavenym STEP

	ORG	0CD30h
LCD30:	JP	NZ,LCCBA	;jeste neni 0, dalsi pruchod
	POP	HL
	LD	(VCEBE),HL
	POP	HL
	LD	(VDCFE),HL
	POP	HL
	JP	LCD70
	DB	014h

	ORG	0CD70h
LCD70:	LD	(VC3FE),HL
	POP	HL
	LD	(VCEBC),HL
	LD	HL,02296h	;puvodni adresa obsluhy MGF operaci
	LD	(V1E05),HL	;nastav BASIC zpatky
	JP	LCDB0

	ORG	0CDB0h
LCDB0:	LD	A,0C3h		;instrukce JP xxxx
	LD	(V1E04),A	;odskok do bloku operaci MGF - vraci se zpet JP
	POP	HL
	RET			;navrat
LCDB7:	LD	HL,000FDh	;obnoveni puvodni obsluhy chyby RST 008h
	LD	(V000E),HL	;presmerovani chyby vyhodnoceni RST 008h
	JP	LCDF0

	ORG	0CDF0h
LCDF0:	LD	A,0CDh		;instrukce CALL xxxx
	LD	(V1BB8),A	;modifikace SCALE BASICu - CALL se vraci zpet
	RET			;navrat
LCDF6:	POP	DE
	POP	BC
	POP	DE
	PUSH	HL
	CALL	LCDB7		;obnoveni obsluhy "Syntax err"
	JP	LCE30

	ORG	0CE30h
LCE30:	LD	A,C
	CP	02h
	JP	NZ,X00FD	;chybove hlaseni "Syntax err"
	LD	HL,VC6B6	;parametricke rovnice
	CALL	X0614		;prikaz LET BASICu
	INC	HL
	JP	LCE70

	ORG	0CE70h
LCE70:	CALL	X0614		;prikaz LET BASICu
	POP	HL
	POP	DE
	JP	LCCB0

;*******************************************************************************
;Generuje negativni puls pro pohyb pera - signal STEP
;*******************************************************************************
LCE78:	DEC	A		;shod signal pro STEP
	OUT	(04Dh),A	;zapis do PB0
	INC	A		;nastav signal pro STEP
	OUT	(04Dh),A	;zapis do PB0
	RET			;navrat
	DB	026h

	ORG	0CEB0h
VCEB0:	DB	040h,058h,000h	;@X EOL - vlastni promenne pro SCALE BASICu
	DB	040h,059h,000h	;@Y EOL
	DB	040h,046h,000h	;@F EOL
	DB	040h,050h,000h	;@P EOL
VCEBC:	DB	05Ah,000h	;do HL
VCEBE:	DB	062h,000h

	ORG	0CEF0h
VCEF0:	DB	'Turn plotter on',00Dh
	DB	000h

	ORG	0CF30h
VCF30:	DB	'Load paper',00Dh
LCF3B:	LD	A,0A0h		;nastaveni GPIO - PCL=OUT
	JP	LCF72

	ORG	0CF70h
LCF70:	LD	A,0A1h		;nastaveni GPIO - PCL=IN
LCF72:	OUT	(04Fh),A	;skupiny
	LD	A,00Dh		;nastaveni GPIO PC
	OUT	(04Fh),A	;PC6=1
	RET			;GPIO nastaven, navrat
LCF79:	CALL	M8113		;vymezerovani editacniho bufferu
	JP	M8855		;vypis textu editacni radky na displej
VCF7F:	DB	001h		;stav signalu pro plotr

	ORG	0CFB0h
LCFB0:	LD	A,(VCF7F)	;stav signalu pro plotr
	AND	004h
	RET	Z
	CALL	LCF70		;nastaveni GPIO 8255 pro zapisovac
	CALL	LD030		;test zapnuti plotru, stav /RDY
	RET	NC		;plotr neni zapnuty, navrat
	JP	LCFF0

	ORG	0CFF0h
LCFF0:	LD	HL,VCF30	;text "Load paper"
	CALL	LD277		;pipni, zobraz na monitoru
LCFF6:	CALL	LD030		;test zapnuti plotru, stav /RDY
	JP	C,LCFF6		;dokud neni plotr READY
	CALL	LCF79		;smazani edit. radku, vypis textu
	RET			;navrat

;******************************************************************************
;Test zapnuti plotru, pripadne hlaska pro obsluhu, at ho zapne, pak
;vyhledani leve krajni polohy pera, nulovani zakladnich promennych
;******************************************************************************
	ORG	0D030h
LD030:	IN	A,(04Eh)	;cti GPIO PC
	RRA			;PC1 do CARRY - signal +/-
	RRA			;signal +/- je pres 10k stazen ke GND
	JP	NC,LD070	;PC1=0 => vypnuty plotr => skoc
	RLA			;PC0 do CARRY - signal /RDY
	JP	C,LD0B6
	JP	LCF3B		;nastaveni GPIO - PCL=OUT
VD03E:	DB	000h,008h


	ORG	0D070h
LD070:	LD	HL,VCEF0	;text "Turn plotter on"
	CALL	LD277		;pipni, zobraz na monitoru
LD076:	IN	A,(04Eh)	;cti PC
	RRA			;PC1 do CARRY
	RRA
	JP	LD0B0
VD07D:	DB	0FFh
VD07E:	DB	001h


	ORG	0D0B0h
LD0B0:	JP	NC,LD076	;cekej na zapnuti plotru
	CALL	LCF79		;smazani edit. radku, vypis textu
LD0B6:	LD	HL,007D0h	;200mm*10 kroku na mm - max. pohyb voziku
LD0B9:	CALL	LCF3B		;nastaveni GPIO - PCL=OUT
	DEC	HL
	JP	LF0D0

	ORG	0D0F0h
LF0D0:	LD	A,001h		;priprava pro STEP - pero se pohybuje doleva
	CALL	LCE78		;impuls pro krok STEP
	CALL	LCF70		;nastaveni GPIO 8255 pro zapisovac
	XOR	A
LD0F9:	DEC	A		;casova prodleva
	JP	NZ,LD0F9
	JP	LD130

	ORG	0D130h
LD130:	LD	A,H		;test na prazdny HL - maximalni 
	OR	L		;posun pisatka - 2000 kroku
	SCF			;nastav CARRY
	RET	Z		;je-li HL=0, navrat
	IN	A,(04Eh)	;precti PC
	RRA			;PC0 do CARRY (READY)
	JP	C,LCF3B		;je-li PC1=1, nastav PCL=OUT
	XOR	A		;nulovani HL
	LD	L,A
	LD	H,A
	JP	LD170

	ORG	0D170h
LD170:	CALL	LF5F0		;plneni promennych
	LD	(VFFB4),HL	;v HL je 0
	LD	(VFBBE),HL
	LD	(VFFB6),HL
	JP	LD1B0
	DB	0EFh

	ORG	0D1B0h
LD1B0:	LD	A,0F2h
	LD	L,A
	LD	(VC172),A	;Y souradnice pocatecniho bodu
	LD	(VFC7E),HL	;v HL je 000F2h
	CALL	LCF3B		;nastaveni GPIO - PCL=OUT
	JP	LD1F0
	DB	01Ch

	ORG	0D1F0h
LD1F0:	LD	B,00Fh		;casova prodleva
LD1F2:	LD	A,002h		;krok "+"
	OUT	(04Eh),A	;zapis do PC
	DEC	A		;smer Y + STEP
	CALL	LCE78		;impuls pro STEP
	XOR	A		;nuluj Acc
LD1FB:	DEC	A		;casova prodleva
	JP	LD230
	DB	0EFh

	ORG	0D230h
LD230:	JP	NZ,LD1FB	;pokud v Acc neni 0, dalsi cyklus
	DEC	B		;sniz pocet zbyvajicich kroku
	JP	NZ,LD1F2	;neni-li 0, dalsi krok STEP
	LD	(VD37D),A	;v A by mela byt 0
	CALL	LCF79		;smazani edit. radku, vypis textu
	JP	LD270

	ORG	0D270h
LD270:	LD	A,001h
	LD	(VD97E),A
	OR	A
	RET			;konec inicializace plotru
LD277:	LD	(VC074),HL	;adresa systemoveho hlaseni - odkaz na text
	CALL	M8113		;vymezerovani editacniho bufferu
	JP	M8E43		;vypis chyboveho hlaseni

	ORG	0D2B0h
LD2B0:	LD	A,(VD07D)
	OR	A
	CALL	Z,LD3F8		;vypocet 100/COS(ATN('0000/'0000))+.5 EOL
	CALL	LC733		;vypocet dvojkoveho doplnku v HL
	EX	DE,HL
	ADD	HL,HL
	ADD	HL,HL
	JP	LD2F0

	ORG	0D2F0h
LD2F0:	ADD	HL,HL
	ADD	HL,HL		;HL*16
	XOR	A
	LD	B,A		;nuluj BC
	LD	C,A
	LD	A,L		;test na nulovost HL
	OR	H
	JP	Z,LD336		;v HL je 0, skoc
	LD	A,B
LD2FB:	ADD	HL,DE
	INC	A
	JP	LFAF0

	ORG	0D330h
LD330:	LD	C,A
	LD	HL,VD4B0
	ADD	HL,BC
	LD	C,(HL)
LD336:	LD	HL,(VD37E)	;napln HL
	LD	A,(VD37C)
	OR	A
	JP	LD370

	ORG	0D370h
LD370:	PUSH	AF
	ADD	HL,BC
	JP	NZ,LD3B6
	LD	A,(VD07D)
	OR	A
	JP	LD3B0
VD37C:	DB	000h
VD37D:	DB	000h
VD37E	DB	001h,02Fh

	ORG	0D3B0h
LD3B0:	JP	Z,LD3B6
	LD	HL,(VD07E)
LD3B6:	LD	(VD57E),HL
	LD	C,L
	LD	H,B
	LD	A,005h
	JP	LD3F0

	ORG	0D3F0h
LD3F0:	ADD	HL,HL
	CALL	LC73C
	ADD	HL,BC
	JP	LD430
LD3F8:	LD	A,H		;test na nulovost HL
	OR	L
	RET	Z		;v HL je 0, navrat
	PUSH	HL
	PUSH	DE
	JP	LDDB0		;vypocet 100/COS(ATN('DE/'(SP)))+.5 EOL

	ORG	0D430h
LD430:	LD	A,L
	LD	(VD8BF),A
	POP	AF
LD435:	LD 	HL,VD37D
	CP	(HL)
	LD	(HL),A
	DEC	HL
	LD	(HL),A
	PUSH	AF
	JP	LD470

	ORG	0D470h
LD470:	ADD	A,004h
	OUT	(04Fh),A	;nastaveni GPIO 8255
	POP	AF
	RET	Z
	LD	HL,(VD03E)
LD479:	DEC	HL
	LD	A,L
	OR	H
	JP	NZ,LD479
	RET

	ORG	0D4B0h
VD4B0:	DB	020h,030h,040h,049h
	DB	000h,000h,000h,000h,000h,000h,000h,000h,000h
	DB	000h,000h,000h,000h,000h

	ORG	0D4F0h
LD4F0:	CALL	LCFB0
	LD	HL,(VFFB0)
	EX	DE,HL
	LD	HL,(VFFB4)
	CALL	LD870
	JP	LD530

	ORG	0D530h
LD530:	LD	(VD8F0),HL
	PUSH	DE
	LD	H,B
	LD	L,C
	LD	(VD9BA),HL
	LD	HL,(VFFB2)
	EX	DE,HL
	JP	LD570

	ORG	0D570h
LD570:	LD	HL,(VFFB6)
	CALL	LD870
	LD	(VD938),HL
	LD	H,B
	LD	L,C
	JP	LD5B0
VD57E:	DB	000h
VD57F:	DB	000h

	ORG	0D5B0h
LD5B0:	LD	(VD974),HL
	XOR	A
	POP	HL
	PUSH	HL
	CALL	LC733		;vypocet dvojkoveho doplnku HL
	ADD	HL,DE
	OR	H
	POP	HL
	PUSH	AF
	JP	LD5F0

	ORG	0D5F0h
LD5F0:	JP	M,LD5F4
	EX	DE,HL
LD5F4:	PUSH	HL
	PUSH	DE
	PUSH	AF
	CALL	LD2B0
	POP	AF
	JP	LD630
VD5FE:	DB	000h,000h

	ORG	0D630h
LD630:	CALL	P,LD9FB
	LD	A,(VD07D)
	OR	A
	LD	HL,(VD8F0)
	CALL	Z,LDB30
	JP	LD670

	ORG	0D670h
LD670:	CALL	LDA39
	POP	HL
	CALL	LC733		;vypocet dvojkoveho doplnku HL
	EX	DE,HL
	POP	BC
	LD	HL,00000h
	PUSH	HL
	JP	LD6B0

	ORG	0D6B0h
LD6B0:	LD	HL,VD8F0
	CALL	LD7F7
	POP	HL
	ADD	HL,DE
	OR	H
	LD	A,(VD57E)
	PUSH	HL
	JP	LD6F0

	ORG	0D6F0h
LD6F0:	JP	P,LD733
	ADD	HL,BC
	EX	(SP),HL
	LD	HL,VD938
	CALL	LD7F7
	JP	LD730
VD6FE:	DB	000h,000h

	ORG	0D730h
LD730:	LD	A,(VD8BF)
LD733:	DEC	A
	JP	NZ,LD733
	LD	HL,VD6FE
	INC	(HL)
	JP	LD770
VD73E:	DB	000h,000h

	ORG	0D770h
LD770:	JP	NZ,LD7B0
	INC	HL
	INC	(HL)
	JP	NZ,LD7B0
	LD	A,03Ch		;INC A
	LD	(VD931),A	;modifikace programu
	JP	LD7B0

	ORG	0D7B0h
LD7B0:	PUSH	BC
	LD	HL,V1C6A
	LD	A,(VD57F)
	LD	B,000h
	LD	C,A
	ADD	HL,BC
	POP	BC
	LD	A,(HL)
	JP	LD7F0

	ORG	0D7F0h
LD7F0:	DEC	A
	JP	NZ,LD7F0
	JP	LDC35
LD7F7:	INC	(HL)
	JP	NZ,LD834
	INC	HL
	INC	(HL)
	JP	LD830

	ORG	0D830h
LD830:	DEC	HL
	JP	Z,LD83C
LD834:	LD	A,(HL)
	RRCA
	RET	NC
	RRCA
	RET	NC
	INC	HL
	INC	HL
	JP	(HL)
LD83C:	POP	DE
	JP	LDAB0

	ORG	0D870h
LD870:	CALL	LC733		;vypocet dvojkoveho doplnku HL
	ADD	HL,DE
	CALL	LC730		;prevod zaporneho cisla na kladne
	EX	DE,HL
	PUSH	DE
	LD	HL,02303h
	JP	LD8B0

	ORG	0D8B0h
LD8B0:	JP	P,LD8B6
	LD	HL,02B02h
LD8B6:	EX	(SP),HL
	CALL	LC733		;vypocet dvojkoveho doplnku HL
	ADD	HL,HL
	ADD	HL,HL
	POP	BC
	DEC	HL
	RET
VD8BF:	DB	000h

	ORG	0D8F0h
VD8F0:	DB	000h,000h,0CDh,07Fh,0D5h,03Eh	;CALL LD9B6, LD A,xx
VD8F6:	DB	064h		;data pro LD A,xx
	LD	(VDC74),A
	LD	HL,VD57F
	JP	LD930

	ORG	0D930h
LD930:	LD	A,(HL)
VD931:	DEC	A
	RET	Z
	CP	02Fh		;'/'
	RET	Z
	LD	(HL),A
	RET
VD938:	DB	000h,000h,0CDh,070h,0D9h,0C9h	;CALL LD970, RET
VD93E:	DB	000h,000h

	ORG	0D970h
LD970:	LD	HL,(VFFB6)
VD973:	DB	03Eh		;LD A,x
VD974:	DB	000h		;hodnota pro LD A,x
	INC	HL
	OUT	(04Fh),A
	LD	(VFFB6),HL
	JP	LD9B0
VD97E:	DB	001h
VD97F:	DB	000h

	ORG	0D9B0h
LD9B0:	LD	A,(VCCFF)	;pohyb Y s prednastavenym STEP
	JP	LCE78		;impuls pro krok STEP
LD9B6:	LD	HL,(VFFB4)
	DB	03Eh		;LD A,x
VD9BA:	DB	000h		;hodnota pro LD A,x
	INC	HL
	JP	LD9F0
	DB	054h

	ORG	0D9F0h
LD9F0:	OUT	(04Fh),A
	LD	(VFFB4),HL
	LD	A,(VCC3F)	;pohyb X s prednastavenym STEP
	JP	LCE78		;impuls pro krok STEP
LD9FB:	LD	B,005h		;pocet prehazovanych byte
	JP	LDA30

	ORG	0DA30h
LDA30:	LD	HL,VD938	;1. adresa dat
	LD	DE,VD8F0	;2. adresa dat
	JP	LC6F4		;prehozeni B word z (HL) na (DE)
LDA39:	EX	DE,HL		;vraceni obsahu na misto
	LD	HL,(VD57F)
	JP	LDA70

	ORG	0DA70h
LDA70:	LD	H,000h
	ADD	HL,HL
	ADD	HL,HL
	PUSH	HL
	ADD	HL,HL
	ADD	HL,DE
	POP	HL
	JP	C,LDD74
	ADD	HL,DE
LDA7C:	LD	(VD6FE),HL
	RET

	ORG	0DAB0h
LDAB0:	LD	A,(VCF7F)	;stav signalu pro plotr
	AND	008h
	CALL	NZ,LCF70	;nastaveni GPIO 8255 pro zapisovac
	LD	A,03Dh		;DEC A
	LD	(VD931),A	;modifikace programu
	JP	LDAF0

	ORG	0DAF0h
LDAF0:	POP	DE
	POP	AF
	CALL	P,LD9FB
	XOR	A
	LD	(VDC74),A
	RET
LDAFA:	LD	HL,(VD5FE)
	JP	LDBF6

	ORG	0DB30h
LDB30:	LD	A,(VDCBF)
	OR	A
	JP	NZ,LDAFA
	LD	HL,(VD73E)
	LD	A,(HL)
	OR	A
	PUSH	DE
	JP	LDB70

	ORG	0DB70h
LDB70:	JP	NZ,LDB77
	LD	HL,(VD93E)
	LD	A,(HL)
LDB77:	INC	HL
	LD	(VD73E),HL
	LD	H,000h
	JP	LDBB0

	ORG	0DBB00h
LDBB0:	LD	L,A
	CALL	LC733		;vypocet dvojkoveho doplnku HL
	LD	A,064h		;'d' (100)
	CALL	LC839
	EX	DE,HL
	LD	HL,(VD5FE)
	JP	LDBF0

	ORG	0DBF0h
LDBF0:	ADD	HL,DE
	LD	(VD5FE),HL
	EX	DE,HL
	POP	DE
LDBF6:	DB	03Eh		;LD A,xx
VDBF7:	DB	064h		;data pro LD A,xx
	CALL	LC73C
	ADD	HL,HL
	ADD	HL,HL
	JP	LDC30

	ORG	0DC30h
LDC30:	XOR	A
	LD	(VDCBF),A
	RET
LDC35:	LD	A,(VD07D)
	OR	A
	JP	NZ,LD6B0
	PUSH	BC
	JP	LDC70

	ORG	0DC70h
LDC70:	LD	HL,(VD5FE)
VDC73:	DB	001h		;LD BC,xxxx
VDC74:	DB	000h,000h	;hodnota pro LD BC,xxxx, modifikovano
	ADD	HL,BC
	POP	BC
	LD	A,000h
	LD	(VDC74),A
	JP	LDCB0

	ORG	0DCB0h
LDCB0: 	LD	(VD5FE),HL
	JP	NC,LD6B0
	PUSH	DE
	LD	A,(VD37C)
	XOR	001h
	JP	LDCF0
VDCBF:	DB	000h

	ORG	0DCF0h
LDCF0:	CALL	LD435
	CALL	LDB30
	PUSH	HL
	CALL	LC733		;vypocet dvojkoveho doplnku HL
	EX	DE,HL
	JP	LDD30
VDCFE:	DB	000h,000h

	ORG	0DD30h
LDD30:	LD	HL,(VD8F0)
	EX	DE,HL
	ADD	HL,DE
	POP	HL
	JP	NC,LDD3A
	EX	DE,HL
LDD3A:	CALL	LDA39
	JP	LDD70

	ORG	0DD70h
LDD70:	POP	DE
	JP	LD6B0
LDD74:	EX	DE,HL
	LD	A,002h
	CALL	LC73C
	JP	LDA7C
VDD7D:	DB	01Eh,014h,000h

	ORG	0DDB0h		;ROM pack 0152Eh - 100/COS(ATN('0000/'0000))+.5 EOL
LDDB0:	LD	HL,(VE0FE)	;pocatecni adresa tohoto programu v ROM-packu
	LD	DE,0152Eh	;offset dat v ROM-packu
	ADD	HL,DE		;odkud se budou prenaset data
	LD	(VDDF3),HL	;uloz pro praci s ROMIN
	JP	LDDF0
VDDBD:	DB	002h,017h,000h

	ORG	0DDF00h
LDDF0:	CALL	M8C00		;ROMIN MONITORu
VDDF3:	DW	0392Eh		;dopoctena hodnota
	DW	00018h		;delka prenasenych dat
	DW	07F82h		;zde ukazatel na text vytvoreny MONITORem
	LD	HL,07F8Bh	;adresa v nactenem textu - "0000/'0000"
	POP	DE
	JP	LDE30

	ORG	0DE30h
LDE30: 	CALL	LDEBB		;prevod DE na 4 byte ASCII, uklada na (HL) - do edit. buferu
	INC	HL
	INC	HL
	INC	HL		;dalsi znak prepisovaneho text "0000))"
	EX	DE,HL		;schovej si ukazatel
	EX	(SP),HL		;z vrcholu SP precti dalsi hodnotu
	EX	DE,HL		;v DE je hodnota z (SP), v HL je ukazatel v buferu
	CALL	LDEBB		;prevod DE na 4 byte ASCII, uklada na (HL)
	PUSH	DE		;uloz prectenou hodnotu z (SP)
	JP	LDE70

	ORG	0DE70h
LDE70:	LD	HL,V23FD	;prepinac RAD/DEG
	LD	A,(HL)		;precti stav prepinace
	PUSH	AF		;uloz si jej
	LD	(HL),000h	;prepni na RAD
	PUSH	HL		;schovej si ukazatel
	LD	HL,07F82h	;pocatek editacniho buferu - upravena data z ROM-packu
	RST	020h		;nacteni 8-mi bitoveho argumentu - vyhodnoceni prikazu
	POP	HL		;obnov si ukazatel prepinace
	JP	LDEB0

	ORG	0DEB0h
LDEB0:	LD	(VD8F6),A	;hodnota precteneho argumentu
	LD	(VDBF7),A
	POP	AF		;obnov si status prepinace
	LD	(HL),A		;obnov nastaveni RAD/DEG
	POP	HL		;obnov registry
	POP	DE
	RET			;navrat
LDEBB:	LD	A,D		;vyssi byte hodnoty do A
	JP	LDEF0		;A prevede na 2 znaky ASCII a ulozi na (HL) - edit. bufer
	DB	01Ch

	ORG	0DEF0h
LDEF0:	CALL	M813B		;"PREVO2" - prevod BIN na 2xASCII
	INC	HL		;dalsi pozice v editacnim buferu
	LD	A,E		;E prevede na 2 ASCII a ulozi na (HL)
	JP	M813B		;"PREVO2" - prevod BIN na 2xASCII a navrat
LDEF8:	PUSH	AF
	CALL	LCFB0		;test zapnuti plotru/vlozeni papiru
	JP	LDF30
VDEFF:	DB	000h

	ORG	0DF30h
LDF30:	LD	HL,VCF7F	;stav signalu pro plotr
	LD	A,(HL)
	AND	003h		;ponechani X/Y a STEP
	LD	(HL),A
	LD	HL,(VFFB0)
	LD	(VF97E),HL
	JP	LDF70

	ORG	0DF70h
LDF70:	LD	HL,(VFFB2)
	LD	(VFB3E),HL
	POP	AF
	CP	018h
	LD	(VDEFF),A
	JP	LDFB0
VDF7F:	DB	001h		;stav signalu pro plotr

	ORG	0DFB0h
LDFB0:	JP	NZ,LDFB7
	LD	(VE17F),A
	RET
LDFB7:	PUSH	AF
	LD	A,(VE17F)
	CP	018h
	JP	LDFF0

	ORG	0DFF0h
LDFF0:	CALL	Z,LE0B2
	XOR A
	LD	(VE17F),A
	POP	AF
	CP	00Dh
	JP	Z,LE8F0
	JP	LE030

	ORG	0E030h
LE030:	CP	008h
	JP	Z,LE670
	CP	00Eh
	JP	Z,LE7F0
	CP	00Fh
	JP	LE070
VE03F:	DB	01Ch

	ORG	0E070h
LE070:	JP	Z,LE7B5
	CP	010h		;je znak pod 010h?
	JP	C,LE0B0		;je, nahrad jej " "
	CP	080h		;je znak pod 080h?
	JP	C,LE0B2		;je, bude se tisknout
	JP	LE0B0

	ORG	0E0B0h
LE0B0:	LD	A,020h		;misto netisknutelnych znaku bude mezera
LE0B2:	LD	HL,01D6Ah	;upraveny pocatek tabulky LO casti offsetu map znaku
	LD	D,000h		;nuluj DE
	LD	E,A		;znak k tisku
	ADD	HL,DE		;vypocet adresy v tabulce na miste MAGBYTE v BASICu
	LD	E,(HL)		;tabulka offsetu pocatku generatoru daneho znaku
	LD	HL,(VE0FE)	;adresa tohoto programu v ROM-packu
	JP	LE0F0

	ORG	0E0F0h
LE0F0:	LD	BC,01500h	;HI cast offsetu v ROM-packu
	CP	02Bh		;jsou znaky do 02Bh? ('+')
	JP	C,LE138		;jsou, skoc
	LD	BC,01600h	;HI cast offsetu v ROM-packu
	JP	LE130
VE0FE:	DB	000h,024h	;adresa tohoto programu v ROM-packu

	ORG	0E130h
LE130:	CP	057h		;jsou znaky do 057h? ('W')
	JP	C,LE138		;jsou, skoc
	LD	BC,01700h	;HI cast offsetu v ROM-packu
LE138:	ADD	HL,BC
	ADD	HL,DE		;v HL je pocatek generatoru tisknuteho znaku
	LD	(VE173),HL	;odkud se ctou data z ROM-packu - tvar znaku k tisku
	JP	LE170

	ORG	0E170h
LE170:	CALL	M8C00		;precte 16 byte z ROM packu - popis kresleni znaku
VE173:	DW	00000h		;hodnota se dopocitava - tvar tisknuteho znaku
	DW	0000Fh		;delka definice znaku
	DW	07F82h		;zde ukazatel na text vytvoreny MONITORem
	LD	HL,07F82h	;kam se precetl tvar daneho znaku
	JP	LE1B0
VE17F:	DB	000h

	ORG	0E1B0h
LE1B0:	LD	A,(HL)		;precti byte vzoru znaku	;pokracovani obsluhy HARD
	LD	B,000h
	LD	E,B
	AND	A
	JP	P,LE1B9		;pokud neni nejvyssi bit (08xh), skoc
	INC	E
LE1B9:	AND	00Fh		;jen spodni nibble - delka definice znaku
	INC	A		;delka je minimalne 1 byte
	LD	D,A
	JP	LE1F0

	ORG	0E1F0h
LE1F0:	EX	DE,HL
	LD	(VE4FE),HL	;delka vzoru kresleneho znaku
	LD	A,(VE17F)
	CP	018h
	JP	NZ,LE235
	JP	LE230
VE1FF:	DB	0FEh

	ORG	0E230h
LE230:	LD	A,(VDEFF)
	CP	049h
LE235:	LD	A,(DE)		;cte se byte ze vzoru kresleneho znaku
	PUSH	DE		;uloz si ukazatel
	JP	NZ,LE23C
	OR	010h
LE23C:	LD	D,B
	JP	LE270

	ORG	0E270h
LE270:	LD	E,B
	RLCA
	RLCA
	JP	NC,LE278
	LD	D,0FCh
LE278:	RLCA
	JP	NC,LE2B2
	JP	LE2B0
VE27F:	DB	0FFh

	ORG	0E2B0h
LE2B0:	LD	E,0FDh
LE2B2:	LD	HL,VE3FF
	AND	(HL)
	RLCA
	JP	NC,LE2BB
	DEC	E
LE2BB:	EX	DE,HL
	JP	LE2F0
VE2BF:	DB	0FFh

	ORG	0E2F0h
LE2F0:	LD	(VE37E),HL
LE2F3:	LD	HL,VE4FF
	DEC	(HL)
	POP	HL
	INC	HL
	JP	Z,LE4B0
	PUSH	HL
	JP	LE330

	ORG	0E330h
LE330:	LD	A,(HL)
	PUSH	AF
	RLCA
	RLCA
	RLCA
	RLCA
	AND	007h
	LD	HL,VE37E
	ADD	A,(HL)
	JP	LE370
	INC E

	ORG	0E370h
LE370:	CALL	LEB70
	POP	AF
	PUSH	AF
	AND	00Fh
	LD	HL,VE37F
	ADD	A,(HL)
	JP	LE3B0
VE37E:	DB	000h
VE37F:	DB	000h

	ORG	0E3B0h
LE3B0:	CALL	LEBF0
	LD	HL,(VFB3E)
	ADD	HL,DE
	LD	(VFFB2),HL
	LD	HL,(VF97E)
	JP	LE3F0

	ORG	0E3F0h
LE3F0:	POP	DE
	ADD	HL,DE
	LD	(VFFB0),HL
	CALL	LECB0
	OR	D
	JP	NZ,LE4F6
	JP	LE430
VE3FF:	DB	000h

	ORG	0E430h
LE430:	POP	AF
	LD	HL,0D97FH
	OR	(HL)
	RLCA
	DEC	HL
	AND	(HL)
	LD	(VD37C),A
	LD	(HL),01H
	JP	LE470

	ORG	0E470h
LE470:	CALL	LE770
	LD	A,(VD97E)
	CALL	LFAFC
	XOR	A
	LD	(VD97F),A
	JP	LE2F3

	ORG	0E4B0h
LE4B0:	LD	A,(VE4FE)
	AND	A
	JP	Z,LE530
	LD	A,(HL)
	AND	080h
	LD	(VD97F),A
	JP	LE4F0

	ORG	0E4F00h
LE4F0:	LD	A,(HL)
	AND	07Fh
	JP	LE0B2
LE4F6:	POP	AF
	XOR	A
	LD	(VD97E),A
	JP	LE2F3
VE4FE:	DB	000h
VE4FF:	DB	000h

	ORG	0E530h
LE530:	LD	A,(VE17F)
	OR	A
	RET	NZ
	LD	A,(VDEFF)
	CP	020h
	JP	C,LEC70
	JP	LE570

	ORG	0E570h
LE570:	LD	A,(VE37E)
	ADD	A,A
	ADD	A,008h
LE576:	CALL	LEB70
	LD	HL,(VFB3E)
	ADD	HL,DE
	JP	LE5B0

	ORG	0E5B0h
LE5B0:	LD	(VFFB2),HL
	LD	HL,(VF97E)
	ADD	HL,BC
	LD 	(VFFB0),HL
	CALL	LECB0
	JP	LE5F0

	ORG	0E5F0h
LE5F0:	OR	D
	JP	NZ,LE633
	LD	A,(VE2BF)
	OR	A
	CALL	Z,LEAF9
	JP	LE630
VE5FE:	DB	000h,000h

	ORG	0E630h
LE630:	CALL	LF333
LE633:	LD	A,(VDF7F)		;stav signalu pro plotr
	LD	(VCF7F),A		;stav signalu pro plotr
	JP	LCF70			;nastaveni GPIO 8255 pro zapisovac
VE63C:	DB	000h,000h
VE63E:	DB	000h,000h

	ORG	0E6700h
LE670:	LD	A,(VE37E)
	DEC	A
	CPL
	CP	003h
	JP	Z,LE67C
	ADD	A,A			;bud se A vynasobi 2-mi
	DB	006h			;LD B,xx - vlozena instrukce bez efektu
LE67C:	DB	0AFh			;XOR A nebo se vynuluje
	JP	LE6B0

	ORG	0E6B0h
LE6B0:	SUB	008h
	JP	LE576
LE6B5:	LD	A,(VE1FF)
	LD	DE,00000h
	LD	B,D
	LD	C,D
	JP	LE6F0

	ORG	0E6F0h
LE6F0:	CALL	LEBF0
	LD	HL,(VFB3E)
	ADD	HL,DE
	LD	(VE8FE),HL
	LD	HL,(VF97E)
	JP	LE730

	ORG	0E730h
LE730:	POP	DE
	ADD	HL,DE
	LD	(VE5FE),HL
	RET
VE736:	DB	'New paper',00Dh

	ORG	0E770h
LE770:	LD	A,(VCF7F)		;stav signalu pro plotr
	RRA
	RRA
	PUSH	AF
	CALL	C,LD4F0
	POP	AF
	INC	A
	PUSH	AF
	RLA
	JP	LE7B0

	ORG	0E7B00h
LE7B0:	CALL	C,LF2F9
	POP	AF
	RET
LE7B5:	CALL	LE876
	LD	A,0FFh
	LD	(VE27F),A
	JP	LEC70

	ORG	0E7F00h
LE7F0:	CALL	LE6B5
	XOR	A
	LD	(VE27F),A
	JP	LE633
LE7FA:	LD	HL,(VE8FE)
	JP	LE830

	ORG	0E830h
LE830:	LD	(VFFB2),HL
	LD	HL,(VE5FE)
	LD	(VFFB0),HL
	CALL	LECB0
	OR	D
	JP	LE870

	ORG	0E870h
LE870:	RET	NZ
	CALL	LE770
	XOR	A
	RET
LE876:	LD	A,(VE27F)
	OR	A
	LD	HL,VD37C
	JP	LE8B0

	ORG	0E8B0h
LE8B0:	RET	NZ
	LD	(HL),A
	PUSH	HL
	CALL	LE7FA
	POP	HL
	RET	NZ
	INC	A
	LD	(HL),A
	CALL	LE6B5
	JP	LE7FA

	ORG	0E8F00h
LE8F0:	CALL	LE876
	LD	A,(VEC7F)
	LD	DE,00000h
	LD	B,D
	LD	C,D
	JP	LE930
VE8FE:	DB	000h,000h

	ORG	0E930h
LE930:	CALL	LEBF0
	LD	HL,(VE63C)
	ADD	HL,DE
	LD	(VFB3E),HL
	LD	(VE63C),HL
	JP	LE970

	ORG	0E970h
LE970:	POP DE
	LD	HL,(VE63E)
	ADD	HL,DE
	LD	(VE63E),HL
	LD	(VF97E),HL
	PUSH	HL
	PUSH	HL
	JP	LE9B0

	ORG	0E9B0h
LE9B0:	CALL	LE6B5
	CALL	LEC70
	POP	HL
	CALL	LECB0
	OR	D
	POP	DE
	JP	LE9F0
VE9BF:	DB	000h

	ORG	0E9F0h
LE9F0:	JP	NZ,LEA35
	LD	A,(VE9BF)
	OR	A
	CALL	Z,LEAF9
	RET
LE9FB:	LD	D,001h
	RET
LE9FE:	POP	AF			;konec PRTOUT
	RET

	ORG	0EA30h
VEA30:	DB	03Ch,013h
	LD	(BC),A
	INC	DE
	NOP
LEA35:	LD	A,(VCF7F)		;stav signalu pro plotr
	AND	001h
	LD	HL,009F6h
	JP	LEA70

	ORG	0EA70h
LEA70:	RET	NZ
	CALL	LC733			;vypocet dvojkoveho doplnku HL
	ADD	HL,DE
	RET	NC
	LD	HL,VE736		;text "New paper"
	CALL	LD277			;pipni, zobraz na monitoru
	JP	LEAB0
	RST	028h			;prazdny byte

	ORG	0EAB0h
LEAB0:	CALL	M89C0			;INKEY MONITORu bez cekani
	CP	043h			;test na klavesu 'C'
	JP	NZ,LEAB0		;cekej na klavesu
	CALL	LCF79			;smazani edit. radku, vypis textu
	LD	A,00Dh
	JP	LEAF0

	ORG	00EAFh
LEAF0:	LD	HL,00000h
	LD	(VE63E),HL
	JP	LDEF8
LEAF9:	XOR	A			;
	DB	001h			;LD BC,xxxx
LEAFB:	LD	A,001h
	JP	LEEB0

	ORG	0EB30h
LEB30:	LD	(VD37C),A		;v A je bud 0 nebo 1
	LD	A,0FFh
	LD	(VD07D),A
	CALL	LE770
	XOR	A
	LD	(VEBBF),A
	RET

	ORG	0EB70h
LEB70:	PUSH	AF
	LD	HL,(VCEBC)
	CALL	LC839
	LD	A,009h
	CALL	LC73C
	LD	B,H
	JP	LEBB0

	ORG	0EBB0h
LEBB0:	LD	C,L
	LD	HL,(VC3FE)
	POP	AF
	CALL	LC839
	LD	A,009h
	CALL	LC73C
	EX	DE,HL
	RET
VEBBF:	DB	000h

	ORG	0EBF0h
LEBF0:	PUSH	AF
	LD	HL,(VCEBE)
	CALL	LC839
	LD	A,00Eh
	CALL	LC73C
	ADD	HL,DE
	JP	LEC30

	ORG	0EC30h
LEC30:	EX	DE,HL
	POP	AF
	LD	HL,(VDCFE)
	CALL	LC839
	LD	A,0Eh
	CALL	LC73C
	ADD	HL,BC
	EX	(SP),HL
	JP	(HL)

	ORG	0EC70h
LEC70:	LD	HL,(VF97E)
	LD	(VFFB0),HL
	LD	HL,(VFB3E)
	LD	(VFFB2),HL
	JP	LE633
VEC7F:	DB	0EEh

	ORG	0ECB0h
LECB0:	LD	D,000h
	LD	A,00Ah
	CALL	LF470
	LD	A,L
	LD	(VC173),A		;X souradnice koncoveho bodu
	LD	A,007h
	JP	LECF0

	ORG	0ECF0h
LECF0:	LD	(VFBBE),HL
	LD	HL,(VFFB2)
	CALL	LF470
	LD	BC,000F2h
	LD	A,C
	JP	LED30

	ORG	0ED30h
LED30:	CP	L
	CALL	C,LE9FB
	CALL	LC733			;vypocet dvojkoveho doplnku HL
	ADD	HL,BC
	LD	(VFC7E),HL
	LD	A,L
	JP	LED70
	DB	014h

	ORG	0ED70h
LED70:	LD	(VC174),A		;Y souradnice koncoveho bodu
	XOR	A
	OR	D
	LD	(V1C0F),A
	RET
VED79:	DB	028h,013h
	DB	002h,012h,002h,013h,000h

	ORG	0EDB0h			;nova obsluha prikazu AXES BASICu
LEDBO:	CALL	LF6F0
	LD	A,(V1C0F)
	OR	A
	RET	NZ
	PUSH	HL
	LD	HL,(VFFB0)
	PUSH	HL
	JP	LEDF0

	ORG	0EDF0h
LEDF0:	LD	A,(VC173)		;X souradnice koncoveho bodu
	PUSH	AF
	XOR	A
	LD	L,A
	LD	H,A
	LD	(VFFB0),HL
	LD	(VC173),A		;X souradnice koncoveho bodu
	JP	LEE30

	ORG	0EE30h			;obsluha HARD BASICu po dekodovani '#'
LEE30:	CALL	LEAF9			;
	CPL
	LD	(VC173),A		;X souradnice koncoveho bodu
	LD	HL,09F6h
	LD	(VFFB0),HL
	JP	LEE70

	ORG	0EE70h
LEE70:	CALL	LEAFB
	POP	AF
	LD	(VC173),A		;X souradnice koncoveho bodu
	LD	A,0F2h
	LD	(VC174),A		;Y souradnice koncoveho bodu
	POP	HL
	JP	LEEB0

	ORG	0EEB0h
LEEB0:	LD	(VFFB0),HL
	LD	HL,00000h
	LD	(VFFB2),HL
	LD	(VFC7E),HL
	JP	LEEF0


	ORG	0EEF0h
LEEF0:	CALL	LEAF9
	LD	HL,006A4h
	LD	(VFFB2),HL
	LD	(VC174),A		;Y souradnice koncoveho bodu
	JP	LEF30
VEEFF:	DB	0EFh

	ORG	0EF30h
LEF30:	CALL	LEAFB			;modifikovany BASIC - vykresleni cele usecky
	POP	HL
	RET
LEF35:	CP	00Dh			;novy vstupni bod PRTOUT
	PUSH	AF			;test na znak <CR>
	JP	LF0B0
LEF3B:	LD	A,000h			;nahrazeni netisknutelneho znaku ' '
	JP	LEF70

;*******************************************************
;zpracovni znaku <CR>
;*******************************************************
	ORG	0EF70h
LEF70:	CALL	M8500			;originalni PRTOUT MONITORu
	LD	A,(VCF7F)		;stav signalu pro plotr
	RRCA
	JP	C,LE9FE
	POP	AF
LEF7B:	PUSH	HL
	PUSH	DE
	JP	LEFB0

	ORG	0EFB0h
LEFB0:	PUSH	BC
	CALL	LDEF8
	POP	BC
	POP	DE
	POP	HL
	RET
LEFB8:	LD	A,B			;obsluha pridaneho COPYS a COPYG BASICu
	LD	(VCF7F),A		;stav signalu pro plotr
	LD	(VDF7F),A		;stav signalu pro plotr
	RET

	ORG	0EFF0h
LEFF0:	LD	A,(V1C0F)		;hodnota z LD	A,000h BASICu
	OR	A
	RET	NZ
	PUSH	HL
	CALL	LEAFB
	POP	HL
	RET
;*******************************************************
;Obsluha pridaneho prikazu COPYx BASICu
;*******************************************************
LEFFB:	LD	C,(HL)
	RST	010h			;test na cifru 0-9 na (HL)
	JP	LF030

	ORG	0F030h
LF030:	LD	A,C
	LD	B,001h			;B=001h
	CP	042h			;'B'
	JP	Z,LFD70			;vykonani COPYB
	CP	053h			;'S'
	JP	Z,LEFB8
	JP	LF070

	ORG	0F070h
LF070:	LD	B,00Eh			;B=00Eh
	CP	054h			;'T' - opis textu obrazovky na plotru
	JP	Z,LF170
	INC	B			;B=00Fh
	CP	047h			;'G' - opis graf. opreaci na plotru
	JP	Z,LEFB8
	JP	X00FD			;Chybove hlaseni "Syntax err"

;*******************************************************
;PRTOUT BASICu
;*******************************************************
	ORG	0F0B0h
LF0B0:	JP	Z,LEF70			;znak byl <CR>, skoc
	CP	020h
	JP	C,LEF3B			;netisknutelny znak, skoc
	JP	LEF70			;zpracovani znaku MONITORem
VF0BB:	DB	04Ch,049h,04Eh,045h,014h	;"LINE"+014h

	ORG	0F0F0h
LF0F0:	PUSH HL
	CALL	M8C00			;ROMIN BASICu
VF0F4:	DW	03510h			;dopocitava se
	DW	001FFh			;512 byte
	DW	01600h			;cilova adresa - podpora RIGHT,LEFT...
	LD	DE,VF134
	JP	LF130

	ORG	0F130h
LF130:	PUSH	DE
	JP	X1600			;podpora LEFT$/RIGHT$/MID$
VF134:	CALL	M8C00			;ROMIN BASICu
	DW	0160Ch
	DW	001FFh
	DW	01600h
	POP	HL
	RET
	DB	010h

	ORG	0F170h
LF170:	CALL	LEFB8			;zpracovani pridaneho COPYT BASICu
	PUSH	HL
	LD	HL,00000h
	LD	(VCEBC),HL
	LD	(VCEBE),HL
	JP	LF1B0

	ORG	0F1B0h
LF1B0:	LD	(VE63E),HL
	LD	(VE63C),HL
	LD	HL,00018h
	LD	(VC3FE),HL
	JP	LF1F0
	DB	014h

	ORG	0F1F0h
LF1F0:	LD	HL,0FFDBh
	LD	(VDCFE),HL
	LD	A,00Dh
	CALL	LDEF8
	POP	HL
	LD	A,(HL)
	JP	LF230

	ORG	0F230h
LF230:	CP	02Ch			;',' - "COPYT,x"
	RET	NZ
	RST	010h			;test, zda je na (HL) cislice 0 az 9
	RST	020h			;nacteni 8-mi bitoveho argumentu
	CALL	LF339
	NOP
	PUSH	HL
	LD	HL,(VFFB2)
	JP	LF43B

;******************************************************************************
;Vstupni bod modifikovaneho prikazu PRINT BASICu - nova obsluha prikazu AT
;******************************************************************************
	ORG	0F270h
LF270:	RST	010h			;test, zda je na (HL) cislice 0 az 9
	RST	020h			;nacteni 8-mi bitoveho argumentu
	PUSH	HL
	PUSH	AF
	INC	A
	CALL	LF3BA
	JP	X0788			;pokracovani klicovym slovem AT BASICu
LF27B:	PUSH	AF
	PUSH	BC
	JP	LF2B0

	ORG	0F2B0h
LF2B0:	CALL	LDEF8
	POP	BC
	POP	AF
	DEC	B
	RET	Z
	JP	LF27B
;dalsi modifikace prikazu AT BASICu
LF2BA:	RST	008h			;porovnani (HL) a byte za RST 008h
	DB	02Ch			;','
	RST	020h			;nacteni 8-mi bitoveho argumentu
	JP	LF2F0

	ORG	0F2F0h
LF2F0:	DEC	HL
	PUSH	AF
	CALL	LF339
	POP	AF
	JP	X07AD			;navrat do puvodni obsluhy AT BASICu
LF2F9:	LD	A,(VD37C)
	OR	A
	JP	LF330

	ORG	0F330h
LF330:	CALL	NZ,M8CD0		;linearni intelpolator MONITORu - kresleni cary
LF333:	LD	A,(VC173)		;X souradnice koncoveho bodu
	JP	X1C60			;preklopeni novych souradnic do starych
LF339:	LD	B,A
	LD	A,(VCF7F)		;stav signalu pro plotr
	JP	LF370

	ORG	0F370h
LF370:	RRCA
	RET	C
	LD	A,020h			;' '
	PUSH	HL
	CALL	LF479
	POP	HL
	RET
LF37A:	LD	HL,(VFFB0)
	JP	LF3B0

	ORG	0F3B0h
LF3B0:	LD	(VE63E),HL
	LD	HL,(VFFB2)
	LD	(VE63C),HL
	RET
LF3BA:	LD	HL,00000h
	JP	LF3F0

	ORG	0F3F0h
LF3F0:	LD	B,A
	LD	A,(VCF7F)		;stav signalu pro plotr
	RRCA
	RET	C
	LD	A,0FFh
	LD	(VE9BF),A
	LD	A,00Dh
	JP	LF430

	ORG	0F430h
LF430:	LD	(VE63E),HL
	CALL	LF27B
	XOR	A
	LD	(VE9BF),A
	RET
LF43B:	LD	(VE63C),HL
	POP	HL
	RET

	ORG	0F470h
LF470:	CALL	LC73C
	LD	A,H
	OR	A
	CALL	NZ,LE9FB
	RET
LF479:	INC	B
	DEC	B
	RET	Z
	JP	LF27B
VF47F:	DB	026h

	ORG	0F4B0h
VF4B0:	CP	00Dh
VF4B2:	RET	Z
	CP	00Ah
	RET	Z
	JP	LEF7B
LF4B9:	LD	(VF4B2),A
	LD	A,(HL)
	JP	LF4F0

	ORG	0F4F0h
LF4F0:	CP	0A7h
	RET	NZ
	RST	010h			;test (HL) - je-li cislo 0..9
	LD	A,(VCF7F)		;stav signalu pro plotr
	RRCA
	RET	NC
	PUSH	HL
	CALL	LF37A
	JP	LF530

	ORG	0F530h
LF530:	POP	HL
	XOR	A
	LD	(VF4B2),A		;nahrada RET Z instrukci NOP
	RET
LF536:	LD	HL,(VFC3C)
	LD	(VCABA),HL
	POP	HL
	JP	LF570

	ORG	0F570h
LF570:	EX	(SP),HL
	LD	DE,V1B7F		;tabulka v BASICu - @X EOL
	JP	LCAFC
LF577:	LD	HL,(VFC3E)
	LD	(VCABA),HL
	JP	LF5B0

	ORG	0F5B0h
LF5B0:	EX	DE,HL
	LD	DE,V1B88		;tabulka v BASICu - @Y EOL
	JP	LCB78
LF5B7:	PUSH	AF
	CALL	LE633
	POP	AF
	JP	LEB30
VF5BF:	DB	010h

	ORG	0F5F0h
LF5F0:	LD	(VC170),A		;X souradnice pocatecniho bodu
	LD	(VFC3C),HL
	LD	(VFC3E),HL
	RET
LF5FA:	CALL	M8500			;presmerovani z GCLEAR BASICu PRTOUT MONITORu
	JP	LF630

	ORG	0F630h
LF630:	PUSH	HL
	XOR	A
	LD	L,A
	LD	H,A
	LD	(VFFB0),HL
	LD	(VFFB2),HL
	LD	(VFC3C),HL
	JP	LF670

	ORG	0F670h
LF670:	LD	(VFC3E),HL
	LD	(VFBBE),HL
	LD	(VC173),A		;X souradnice koncoveho bodu
	LD	A,0F2h
	LD	L,A
	JP	LF6B0
	DB	027h

LF6B0:	LD	(VC174),A		;Y souradnice koncoveho bodu
	LD	(VFC7E),HL
	POP	HL
LF6B7:	PUSH	HL			;vstup modifikovaneho prekopeni souradnic
	CALL	LEAF9
	LD	A,001h
	JP	LF73B

	ORG	0F6F0h			;pocatek modifikovaneho PLOT BASICu
LF6F0:	LD	A,(VCF7F)		;stav signalu pro plotr
	RRCA
	JP	C,LC8FB			;modifikace BASICu
LF6F7:	LD	A,(HL)			;cti znak z buferu
	OR	A
	JP	Z,LF739			;je-li prazdny vyskok ven
	JP	LF730
	DB	0A2h

	ORG	0F730h
LF730:	CP	03Ah			;':'
	JP	Z,LF739			;je-li ':' vyskok ven
	INC	HL			;posun v buferu
	JP	LF6F7			;dalsi znak
LF739:	POP	DE
	RET
LF73B:	CALL	LF3BA
	POP	HL
	RET

	ORG	0F770h			;Presmerovana obsluha "DEF" BASICu
LF770:	LD	A,(HL)			;cti znak interpretovaneho radku BASICu
	CP	09Fh			;token FNC BASICu
	JP	Z,X0CB3			;zaregistrovani jmena fce a kontrola jejiho typu
	POP	DE
	LD	DE,VF0BB		;text "LINE"+014h
	LD	C,004h			;4 znaky
LF77C:	LD	A,(DE)			;cti znak z (DE) - ukazatel na "LINE"+014h
	JP	LF7B0

	ORG	0F7B0h
LF7B0:	CP	(HL)			;porovnej se znakem radku BASICu
	JP	NZ,X00FD		;neni shoda - chybove hlaseni "Syntax err"
	INC	DE			;dalsi znak textu "LINE"
	INC	HL			;dalsi znak radku BASICu
	DEC	C			;sniz pocitadlo znaku
	JP	NZ,LF77C		;jeste neni cele "LINE", dalsi znak
	LD	DE,VFF30
	JP	LF7F0

	ORG	0F7F0h			;nacita prarametry za "LINE" a ukada je na 0FF30h
LF7F0:	DEC	HL			;posledni znak "LINE" v radku BASICu
LF7F1:	PUSH	DE
	RST	010h			;test (HL) - je-li cislo 0..9
	RST	020h			;nacteni 8-mi bitoveho argumentu
	CP	001h			;
	JP	C,LF878			;pokud bylo A=0 -> "Syntax err"
	JP	NZ,LF830		;pokud A<>001h, skoc
	INC	A
	JP	LF830

	ORG	0F830h
LF830:	POP	DE			;VFF30
	LD	(DE),A
	INC	DE			;VFF31
	XOR	A			;nuluj A
	LD	(DE),A
	LD	A,(HL)			;znak z radku BASICu
	CP	02Ch			;','
	JP	Z,LF7F1
	JP	LF870
	DB	000h,014h

	ORG	0F870h
LF870:	LD	A,E
	CP	03Fh			;test, zda ve DE neni jiz 0FF40h
	JP	NC,LF878		;neni, skoc
	RRCA
	RET	NC			;navrat
LF878:	LD	HL,VFF30		;VFF30
	LD	(HL),000h		;1 byte VFF30 bude 0 - nic se nevyhodnotilo
	JP	X00FD			;Chybove hlaseni "Syntax err."

	ORG	0F8B0h
LF8B0:	LD	B,A
	DEC	A
	JP	Z,LFA76
	DEC	A
	JP	Z,LF9B3
	LD	HL,VDDBD
	DEC	A
	JP	LF8F0

	ORG	0F8F0h
LF8F0:	JP	Z,LF9B3
	LD	HL,VEA30
	DEC	A
	JP	Z,LF9B3
	LD	HL,VED79
	JP	LF930

	ORG	0F930h
LF930:	DEC	A
	JP	Z,LF9B3
	LD	A,B
	INC	A
	JP	Z,LF976
	CALL	X1C58			;presun koncovych souradnic na pocatecni
	JP	LF970
	DB	010h

	ORG	0F970h
LF970:	CALL	M8C7D			;"POINT" BASICu - vykresleni bodu
	JP	LEFF0
LF976:	LD	HL,VFF30
	LD	A,(HL)
	OR	A
	JP	LF9B0
VF97E:	DB	002h
VF97F:	DB	001h			;argument prikazu

	ORG	0F9B0h
LF9B0:	JP	Z,LEFF0
LF9B3:	LD	A,(VEBBF)
	CP	B
	JP	Z,LFA31
	LD	(VD73E),HL
	JP	LF9F0

	ORG	0F9F0h
LF9F0:	LD	(VD93E),HL
	XOR	A
	LD	L,A
	LD	H,A
	LD	(VD5FE),HL
	INC	A
	LD	(VD37C),A
	JP	LFA30

	ORG	0FA30h
LFA30:	XOR	A
LFA31:	LD	(VDCBF),A
	LD	A,B
	LD	(VEBBF),A
	XOR	A
	LD	(VD07D),A
	JP	LFA70
VFA3F:	DB	001h

	ORG	0FA70h
LFA70:	CALL	M8CD0			;"INPOL" - linearni interpolator
	JP	LE770
LFA76:	LD	HL,VCF7F		;stav signalu pro plotr
	LD	A,(HL)			;cti stav
	AND	003h
	LD	(HL),A			;vrat zpatky na misto
	JP	LFAB0

	ORG	0FAB0h
LFAB0:	LD	A,(V1C0F)		;hlidani oblasti kresleni usecky
	OR	A
	RET	NZ
	INC	A
	JP	LEB30
LFAB9:	CP	0A6h			;'*' - token pro nasobeni
	RET	NZ
	LD	BC,V1B85		;parametricka rovnice @7*@Y EOL
	RET

	ORG	0FAF0h
LFAF0:	JP	C,LD2FB
	DEC	A
	CP	010h
	JP	Z,LD336
	JP	LD330
LFAFC:	PUSH	AF
	JP	LFB30

	ORG	0FB30h
LFB30:	CALL	C,LD435
	POP	AF
	RET	P
	JP	M8C7D			;"POINT" MONITORu - vykresleni bodu
LFB38:	LD	A,(HL)			;obsluha TYPE BASICu
	CP	0A6h
	JP	LFB70
VFB3E:	DB	000h,000h

	ORG	0FB70h
LFB70:	CALL	NZ,LCBF5
	RST	010h
	RST	008h			;test shody znaku (HL) a za RST 008h
	DB	03Bh			;';'
	LD	BC,01110h		;offset v ROM-packu
LFB79:	EX	DE,HL			;pokracovani HARD BASICu
	LD	HL,(VE0FE)		;adresa tohoto programu v ROM-packu
	JP	LFBB0

	ORG	0FBB0h
LFBB0:	PUSH	AF
	ADD	HL,BC			;offset v ROM-packu - 012C6h
	LD	(VF0F4),HL		;zdrojova adresa pro ROMIN
	EX	DE,HL			;ukazatel BASICu zpatky do HL
	CALL	LF0F0			;predun dat z ROM-packu
	POP	AF
	RET	Z
	JP	LFBF0
VFBBE:	DB	078h,000h		;souradnice bodu X

	ORG	0FBF0h
LFBF0:	CALL	X0AA3			;varadr BASICu
	PUSH	HL
	LD	HL,VFC70		;E5 (-76) EOL
	CALL	X0619			;prikaz LET BASICu s vlastnimi parametry
	POP	HL
	RST	08H
	INC	L
	JP	LFC30

	ORG	0FC30h
LFC30:	CALL	X0AA3			;varadr BASICu
	PUSH	HL
	LD	HL,VFC77		;E5 (-74) EOL
	CALL	X0619			;prikaz LET BASICu s vlastnimi parametry
	POP	HL
	RET
VFC3C:	DB	050h,000h
VFC3E:	DB	000h,000h

	ORG	0FC70h
VFC70:	DB	0E5h,028h,0A5h,037h,036h,029h,000h
VFC77:	DB	0E5h,028h,0A5h,037h,034h,029h,000h
VFC7E:	DB	063h,000h		;souradnice bodu Y

;******************************************************************************
;Obsluha pridane funkce HARD BASICu - prikaz HARDCOPY
;******************************************************************************
	ORG	0FCB0h
LFCB0:	RST	008h			;test shody znaku (HL) a za RST 008h
	DB	0EAh			;0EAh - token pridaneho prikazu COPY
	LD	A,(HL)			;dalsi znak v (HL)
	CP	023h			;'#'
	INC	HL			;dalsi znak v (HL)
	JP	Z,LFE30
	NOP
	RST	020h			;nacteni 8-mi bitoveho argumentu
	LD	(VF97F),A		;hodnota 1. nacteneho parametru
	JP	LFCF0

	ORG	0FCF0h
LFCF0:	RST	008h			;test shody znaku (HL) a za RST 008h
	DB	02Ch			;','
	RST	020h			;nacteni 8-mi bitoveho argumentu
	LD	(VF97E),A		;hodnota 2. nacteneho parametru
	DEC	HL
	RST	010h			;test zda je na (HL) cislice
	LD	A,000h
	JP	Z,LFD33			;byl-li parametr "0", skoc
	JP	LFD30

	ORG	0FD30h
LFD30:	RST	008h			;test shody znaku (HL) a za RST 008h
	DB	02Ch			;','
	RST	020h			;nacteni 8-mi bitoveho argumentu
LFD33:	LD 	(VFA3F),A		;hodnota 3. nacteneho parametru
	XOR	A
	LD	BC,012C6h
	JP	LFB79
VFD3D:	DB	000h,076h
	DB	014h

	ORG	0FD70h
LFD70:	PUSH	HL
	CALL	M8C00			;ROMIN MONITORu
	DW	01952h
	DW	00A00h
	DW	01946h
	LD	A,03Ch			;'<'
	JP	LFDF0

	ORG	0FDB0h
LFDB0:	LD	HL,(VFD3D)		;obsluha pridaneho prikazu HARD BASICu
	OR	A			;nuluj CARRY
	RLA				;vynasob 2-mi
	LD	E,A
	LD	D,000h
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	JP	LE1B0

	ORG	0FDF0h
LFDF0:	LD	(V2145),A		;nizsi byte+2 bufferu IMS-2
	CALL	M8C00			;ROMIN MONITORu - obnoveni casti BASICu
	DW	006E5h			;zacatek dat v ROM-packu
	DW	00580h			;delka prenasenych dat-1
	DW	006D9h			;cilova v RAM - posun o 0C byte - hlavicka BASICu
	POP	HL
	RET
	DB	0FFh,0FFh

	ORG	0FE30h
LFE30:	NOP

	ORG	0FF30h
VFF30:	DB	000h,000h,000h,000h,000h,000h,000h,000h
	DB	000h,000h,000h,000h,000h,000h,000h,000h

	ORG	0FF70h
VFF70:	DB	000h,000h,000h,000h
	DB	000h,000h,000h,000h
	DB	000h,000h,000h,000h
	DB	000h,000h,000h,000h

	ORG	0FFB0h
VFFB0:	DB	050h,000h
VFFB2:	DB	000h,000h
VFFB4:	DB	000h,000h
VFFB6:	DB	000h,000h
VFFB8:	DB	000h,000h		;tabulka 4x hodnota crntadr
VFFBA:	DB	000h,000h
VFFBC:	DB	000h,000h
VFFBE:	DB	000h,000h

